#*************************************************************
# Progamm 			absorption
# Sinn des Programms: 		Berechnung der Absorption in ISA-Atmosphäre
# Sinn der Einheit  :		Ausgabe
# Name der Datei    :		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		absorption_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	6
# von:				6
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.04.2018
# Letzte Änderung: 		04.06.2020
#*************************************************************


#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os


import matplotlib.pyplot as plt

class Ausgabe:

  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")          


  def schirm_ausgabe(self,i_max,h,kappa,Intens):
    print(i_max,"Schirmaugabe")
    for i in range(i_max):
      print (f"{i:7}", f"{h[i]:.1f}", f"{Intens[i]:.6f}", f"{kappa[i]:.6f}")
      #print (i, h[i], Intens[i])
      
  def datei_ausgabe(self, ausgabe_datei, i_max, h, kappa, Intens):  #, Intens_absorbiert):
    fobj_out = open(ausgabe_datei,"w")
    for i in range(i_max):
      fobj_out.write(f"{i:7}")
      fobj_out.write("\t")
      fobj_out.write(f"{h[i]:.1f}")      
      fobj_out.write("\t")
      fobj_out.write(f"{Intens[i]:.6f}") 
      fobj_out.write("\t")
      fobj_out.write(f"{kappa[i]:.6f}") 
      fobj_out.write("\n")
    fobj_out.close()
    


  def graphik_ausgabe(self,i_max, h, kappa_init, Intens):
    titel = "Intensitätsverlauf bei kappa_init =" + str(kappa_init)
    h_min=0.0
    h_max=0.0
    y_min=0.0
    y_max=0.0
    for i in range(i_max):
      if h_min >= h[i]:
        h_min = h[i]
      if h_max <= h[i]:
        h_max = h[i]
      if y_min >= Intens[i]:
        y_min = Intens[i]
      if y_max <= Intens[i]:
        y_max = Intens[i]
    
    plt.plot(h, Intens, 'r.',label=r'numerische Lösung')
    h_min-=(h_max-h_min)/10.0
    h_max+=(h_max-h_min)/10.0
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/10.0
    plt.axis([h_min, h_max, y_min, y_max])
    plt.title(titel)
    plt.xlabel("h [m]")
    plt.ylabel('Intensität [W/m²]')
    plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    # Diagramm speichern 
    plt.savefig("Intensitaetsverlauf_kappa="+str(kappa_init)+".png", format='png')
     # Diagramm anzeigen:
    plt.show()

